Updated: 2014-02-21 Due date:
PHP Version:
Has patch: No
Complexity: easy
Affected Flow version: (any)
Subject: Object Route Parts should take persistence_object_identifier into account
Description

If no uriPattern is set for a Object Route Part it defaults to the identity properties of the entity. It should also work to fallback to the
persistence_object_identifier instead which doesn't happen atm but results in an exception.

Associated revisions
Revision 3ca23850 - 2013-10-08 19:30 - Bastian Waidelich

[BUGFIX] Object Route Parts fall back to technical identifier

As described in the routing section of the documentation, the
`Object Route Parts`` should use the technical identifier to
represent an object if no uriPattern is specified and the
specified object does not contain any identity properties.

Instead an exception was thrown if no uriPattern could be
determined because ``ClassSchema::getIdentityProperties()``
doesn't return the property name of the technical identifier.

This change fixes this by falling back by skipping the
ObjectPathMapping if no uriPattern is defined.

Change-Id: Ic06641be676ab514b8004164e90ffd15b6730cca
Releases: master, 2.0
Fixes: #51082

Revision f81d39fe - 2014-02-21 22:16 - Bastian Waidelich

[BUGFIX] Object Route Parts fall back to technical identifier

As described in the routing section of the documentation, the
`Object Route Parts`` should use the technical identifier to
represent an object if no uriPattern is specified and the
specified object does not contain any identity properties.

Instead an exception was thrown if no uriPattern could be
determined because ``ClassSchema::getIdentityProperties()``
doesn't return the property name of the technical identifier.
This change fixes this by falling back by skipping the
ObjectPathMapping if no uriPattern is defined.

Change-Id: Ic06641be676ab514b8004164e90ffd15b6730cca
Releases: master, 2.1, 2.0
Fixes: #51082

History
#1 - 2013-08-15 10:46 - Bastian Waidelich

FYI: This is how it used to be. The IdentityRoutePart uses ClassSchema::getIdentityProperties() to retrieve the properties that identify an entity.
Apparently this does not work any longer if an object only uses the automagical persistence_object_identifier..

#2 - 2013-08-15 10:47 - Christian Müller
- Status changed from New to Accepted

Alright, so this is really a bug. I was not sure if the current behavior was intentional.

#3 - 2013-10-08 17:34 - Bastian Waidelich
- Assigned To set to Bastian Waidelich

I'm fixing this now

#4 - 2013-10-08 19:30 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24490

#5 - 2013-10-15 13:36 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:3ca238501129a075a4b1dfe67b536e9df2fb2081.

#6 - 2014-02-19 17:31 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.0 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/27729
#7 - 2014-02-19 17:43 - Gerrit Code Review

Patch set 2 for branch 2.0 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/27729

#8 - 2014-02-21 22:15 - Gerrit Code Review

Patch set 3 for branch 2.0 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/27729

#9 - 2014-02-21 22:16 - Gerrit Code Review

Patch set 4 for branch 2.0 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/27729

#10 - 2014-02-21 22:36 - Bastian Waidelich
- Status changed from Under Review to Resolved

Applied in changeset commit:f81d39fe5a2a8b636e2c7e51643c6cb5df9931ca.
